org.apache.felix.connect.felix.framework.util

## Class Util

- java.lang.Object
- - org.apache.felix.connect.felix.framework.util.Util

    public class Util
    extends Object

### Constructor Summary

Constructors
Constructor and Description
`Util()`

### Method Summary

Methods
`static String` `base64Encode(String s)`
`static String` `encode(byte[] in, int len)` Encode a raw byte array to a Base64 String.
`static void` `encode(InputStream in, OutputStream out, int len)`
`static long` `getBundleIdFromModuleId(String id)` Converts a module identifier to a bundle identifier.
`static String` `getClassName(String className)`
`static String` `getClassPackage(String className)`
`static String` `getDefaultProperty(String name)`
`static int` `getModuleRevisionFromModuleId(String id)` Converts a module identifier to a bundle identifier.
`static String` `getResourcePackage(String resource)`
`static boolean` `isServiceAssignable(org.osgi.framework.Bundle requester, org.osgi.framework.ServiceReference ref)` This method determines if the requesting bundle is able to cast the specified service reference based on class visibility rules of the underlying modules.
`static Class` `loadClassUsingClass(Class clazz, String name)` This is a simple utility class that attempts to load the named class using the class loader of the supplied class or the class loader of one of its super classes or their implemented interfaces.
`static String` `substVars(String val, String currentKey, Map cycleMap, Properties configProps)` This method performs property variable substitution on the specified value.

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Constructor Detail

#### Util

    public Util()

### Method Detail

#### getDefaultProperty

    public static String getDefaultProperty(String name)

#### getBundleIdFromModuleId

    public static long getBundleIdFromModuleId(String id)

Converts a module identifier to a bundle identifier. Module IDs are typically `<bundle-id>.<revision>`; this method returns only the portion corresponding to the bundle ID.

#### getModuleRevisionFromModuleId

    public static int getModuleRevisionFromModuleId(String id)

Converts a module identifier to a bundle identifier. Module IDs are typically `<bundle-id>.<revision>`; this method returns only the portion corresponding to the revision.

#### getClassName

    public static String getClassName(String className)

#### getClassPackage

    public static String getClassPackage(String className)

#### getResourcePackage

    public static String getResourcePackage(String resource)

#### loadClassUsingClass

    public static Class loadClassUsingClass(Class clazz,
                            String name)

This is a simple utility class that attempts to load the named class using the class loader of the supplied class or the class loader of one of its super classes or their implemented interfaces. This is necessary during service registration to test whether a given service object implements its declared service interfaces.

To perform this test, the framework must try to load the classes associated with the declared service interfaces, so it must choose a class loader. The class loader of the registering bundle cannot be used, since this disallows third parties to register service on behalf of another bundle. Consequently, the class loader of the service object must be used. However, this is also not sufficient since the class loader of the service object may not have direct access to the class in question.

The service object's class loader may not have direct access to its service interface if it extends a super class from another bundle which implements the service interface from an imported bundle or if it implements an extension of the service interface from another bundle which imports the base interface from another bundle. In these cases, the service object's class loader only has access to the super class's class or the extended service interface, respectively, but not to the actual service interface.

Thus, it is necessary to not only try to load the service interface class from the service object's class loader, but from the class loaders of any interfaces it implements and the class loaders of all super classes.

Parameters:
  `svcObj` - the class that is the root of the search.
  `name` - the name of the class to load.
Returns:
  the loaded class or `null` if it could not be loaded.

#### isServiceAssignable

    public static boolean isServiceAssignable(org.osgi.framework.Bundle requester,
                              org.osgi.framework.ServiceReference ref)

This method determines if the requesting bundle is able to cast the specified service reference based on class visibility rules of the underlying modules.

Parameters:
  `requester` - The bundle requesting the service.
  `ref` - The service in question.
Returns:
  `true` if the requesting bundle is able to case the service object to a known type.

#### base64Encode

    public static String base64Encode(String s)
                               throws IOException

Throws:
  `IOException`

#### encode

    public static String encode(byte[] in,
                int len)
                         throws IOException

Encode a raw byte array to a Base64 String.

Parameters:
  `in` - Byte array to encode.
  `len` - Length of Base64 lines. 0 means no line breaks.
Throws:
  `IOException`

#### encode

    public static void encode(InputStream in,
              OutputStream out,
              int len)
                       throws IOException

Throws:
  `IOException`

#### substVars

    public static String substVars(String val,
                   String currentKey,
                   Map cycleMap,
                   Properties configProps)
                            throws IllegalArgumentException

This method performs property variable substitution on the specified value. If the specified value contains the syntax `${<prop-name>}`, where `<prop-name>` refers to either a configuration property or a system property, then the corresponding property value is substituted for the variable placeholder. Multiple variable placeholders may exist in the specified value as well as nested variable placeholders, which are substituted from inner most to outer most. Configuration properties override system properties.

Parameters:
  `val` - The string on which to perform property substitution.
  `currentKey` - The key of the property being evaluated used to detect cycles.
  `cycleMap` - Map of variable references used to detect nested cycles.
  `configProps` - Set of configuration properties.
Returns:
  The value of the specified string after system property substitution.
Throws:
  `IllegalArgumentException` - If there was a syntax error in the property placeholder syntax or a recursive variable reference.